#PomPi 2016 Copyright 2016-2018, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end

=begin
###This code is based on Linetool by @Last Software (Acquired by Google) see below ### Thanks!###
Finally all went to Trimble. So the credits.... distribute among themselves :-)
Modified, extended by Dezmo (2016). 

###This code is also based on part of TIG code:
The 2D Tools are © TIG 2009.
Permission to use, copy, modify, and distribute this software for any purpose, without fee*, 
is hereby granted, provided that the above copyright notice appears in all copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE.
The 2D Tools are © TIG 2009.
=end

# The "lines" created by this tool, handled back to PomPi to make pipe, and pipe@bend.


# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
# Copyright 2005-2007, Google, Inc.

# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
require 'sketchup.rb'


module Dezmo_pompi2016  #dez
class Pompi_line_tool_auto


	def getExtents
		bbox=Sketchup.active_model.bounds
		bbox.add(@ip.position)if @ip and @ip.valid?
		bbox.add(@ip1.position)if @ip1 and @ip1.valid?
		bbox.add(@ip2.position)if @ip2 and @ip2.valid?
		bbox.add(@ip3.position)if @ip3 and @ip3.valid?
		return bbox
	end


	def initialize(kind,rbe)
		@kind="pipe_auto"
		@rbe=rbe
		
		@ip=nil
		@ip1=nil
		@ip2=nil
		@xdown=0
		@ydown=0
		@perpi=false
Sketchup.active_model.start_operation("PomPi Line",true)
Sketchup.active_model.selection.clear
		@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_pb.png"), 0, 0)
	end

	# The activate method is called by SketchUp when the tool is first selected.
	# it is a good place to put most of your initialization
	def activate
		# The Sketchup::InputPoint class is used to get 3D points from screen
		# positions.  It uses the SketchUp inferencing code.
		# In this tool, we will have two points for the endpoints of the line.
		@ip=Sketchup::InputPoint.new
		@ip1=Sketchup::InputPoint.new
		@ip2=Sketchup::InputPoint.new
		@drawn=false
		@perpi=false

		# This sets the label for the VCB
		Sketchup::set_status_text("Length",SB_VCB_LABEL)
		self.reset(nil)
	end

	# deactivate is called when the tool is deactivated because
	# a different tool was selected
	def deactivate(view)


		@lines.each{|e|e.erase! if e.valid?}

		view.model.active_entities.add_curve(@points)if @points[1]

		Sketchup::set_status_text("",SB_PROMPT)
		Sketchup::set_status_text("",SB_VCB_LABEL)
		Sketchup::set_status_text("",SB_VCB_VALUE)
		view.invalidate if @drawn
	end

	def onSetCursor()
		#return nil if RUBY_PLATFORM =~ /darwin/
		UI::set_cursor(@cursor)if @cursor
	end

	# The onMouseMove method is called whenever the user moves the mouse.
	# because it is called so often, it is important to try to make it efficient.
	# In a lot of tools, your main interaction will occur in this method.
	def onMouseMove(flags, x, y, view)

		if @state == 0
			# We are getting the first end of the line.  Call the pick method
			# on the InputPoint to get a 3D position from the 2D screen position
			# that is bassed as an argument to this method.
			@ip.pick view, x, y
			if @ip != @ip1
				# if the point has changed from the last one we got, then
				# see if we need to display the point.  We need to display it
				# if it has a display representation or if the previous point
				# was displayed.  The invalidate method on the view is used
				# to tell the view that something has changed so that you need
				# to refresh the view.
				view.invalidate if( @ip.display? or @ip1.display? )
				@ip1.copy! @ip
				# set the tooltip that should be displayed to this point
				view.tooltip=@ip1.tooltip
				Sketchup::set_status_text("Start-Point",SB_VCB_LABEL)
				Sketchup::set_status_text(" - Pick Start Point...",SB_PROMPT)
				if @ip1.valid?
				  px=@ip1.position.x.to_s
				  py=@ip1.position.y.to_s
				  pz=@ip1.position.z.to_s
				  msg=("["+px+","+py+","+pz+"]").gsub('mm','')
				  Sketchup::set_status_text(msg,SB_VCB_VALUE)
				end#if
			end
		else
			# Getting the second end of the line
			# If you pass in another InputPoint on the pick method of InputPoint
			# it uses that second point to do additional inferencing such as
			# parallel to an axis.
			@ip2.pick view, x, y, @ip1
			view.tooltip=@ip2.tooltip if @ip2.valid?
			view.invalidate
			# Update the length displayed in the VCB
			if @ip2.valid?
				if (@points.length>1)
					va1=@points[-2].vector_to @points[-1] 
					plane_per = [@points[-1],va1] if va1.length>0
					@per_point = @ip2.position.project_to_plane(plane_per) if va1.length>0
				end
				#p1=@ip1.position
				p1=@points[-1]
				p2=@ip2.position if !@perpi
				p2=@per_point if @perpi				
				length=p1.distance(p2)
				vcbtext=length.to_s.gsub('~','')
				vcbtext=length.to_s.gsub('~','') + "/" + @text if @text
				Sketchup::set_status_text(vcbtext,SB_VCB_VALUE)

			end
			Sketchup::set_status_text("Length/Angle",SB_VCB_LABEL)
			Sketchup::set_status_text("Pick End Point [Hit down key to toggle perpendicular lock] [Press Return for pipe or Double-click the Last-Point to End this Line-Set] [Double Right-click to undo last line].",SB_PROMPT)
			# Check to see if the mouse was moved far enough to create a line.
			# This is used so that you can create a line by either draggin
			# or doing click-move-click
			if (x-@xdown).abs > 10 || (y-@ydown).abs > 10
				@dragging=true
			end
		end
	end

	# The onLButtonDOwn method is called when the user presses the left mouse button.
	def onLButtonDown(flags, x, y, view)
		# When the user clicks the first time, we switch to getting the
		# second point.  When they click a second time we create the line
		# and make the second point the first point etc

		if @state == 0
			@ip1.pick view, x, y
			if @ip1.valid?
				@state=1
				Sketchup::set_status_text("Length",SB_VCB_LABEL)
				Sketchup::set_status_text("Pick End Point [Hit down key to toggle perpendicular lock] [Press Return for pipe or Double-click the Last-Point to End this Line-Set] [Double Right-click to undo last line].",SB_PROMPT)
				@xdown=x
				@ydown=y
				p1=@ip1.position
				@points<<p1
			end
		else
			# create the line on the second click
			if @ip2.valid?
				view.lock_inference
				p1=@ip1.position
				@ip1.copy!(@ip2)
				p2=@ip2.position if !@perpi
				p2=@per_point if @perpi
				@ip1 = Sketchup::InputPoint.new(p2) if @perpi
				if p1.distance(p2)>0			
					self.create_geometry(p1,p2,view)
					@points<<p2
					@ip2.clear
					@state=1
				end
			end
		end
		# Clear any inference lock
		view.lock_inference
	end

	# The onLButtonUp method is called when the user releases the left mouse button.
	def onLButtonUp(flags, x, y, view)
		# If we are doing a drag, then create the line on the mouse up event
		view.lock_inference
		if @dragging && @ip2.valid?
			p1=@ip1.position
			@ip1.copy!(@ip2)
			p2=@ip2.position if !@perpi
			p2=@per_point if @perpi
			@ip1 = Sketchup::InputPoint.new(p2) if @perpi
			self.create_geometry(p1,p2,view)
			view.invalidate
			@points<<p2
			@ip2.clear
			@state=1
		end
	end

	# onKeyDown is called when the user presses a key on the keyboard.
	# We are checking it here to see if the user pressed the shift key
	# so that we can do inference locking
	def onKeyDown(key, repeat, flags, view)
		if( key == CONSTRAIN_MODIFIER_KEY && repeat == 1 )
			@shift_down_time=Time.now
			# if we already have an inference lock, then unlock it
			if( view.inference_locked? )
				# calling lock_inference with no arguments actually unlocks
				view.lock_inference
			elsif( @state == 0 && @ip1.valid? )
				view.lock_inference @ip1
			elsif( @state == 1 && @ip2.valid? )
				view.lock_inference @ip2, @ip1
			end
		end
		if( key == VK_DOWN )
			if( @perpi==false )
				@perpi=true if @state == 1 and @points.length>1
			else
				@perpi=false
			end
		end

		###
	end

	# onKeyUp is called when the user releases the key
	# We use this to unlock the interence
	# If the user holds down the shift key for more than 1/2 second, then we
	# unlock the inference on the release.  Otherwise, the user presses shift
	# once to lock and a second time to unlock.
	def onKeyUp(key, repeat, flags, view)
		if( key == CONSTRAIN_MODIFIER_KEY &&
			view.inference_locked? &&
			(Time.now - @shift_down_time) > 0.5 )
			view.lock_inference
		end

	end

	def enableVCB?
	   return true
	end

	# onUserText is called when the user enters something into the VCB
	# In this implementation, we create a line of the entered length if
	# the user types a length while selecting the second point
	def onUserText(text, view)
		# We only accept input when the state is 1 (i.e. getting the second point)
		# This could be enhanced to also modify the last line created if a length
		# is entered after creating a line.
		return if not @state == 1
		return if not @ip2.valid?
		# The user may type in something that we can't parse as a length
		# so we set up some exception handling to trap that
		begin
			value=text.to_l
		rescue
			# Error parsing the text
			UI.beep
			#puts "Cannot convert "+text+" to a Length"
			value=nil
			Sketchup::set_status_text("",SB_VCB_VALUE)
			Sketchup::set_status_text("Cannot convert "+text+" to a Length",SB_PROMPT)
		end
		return if !value
		# Compute the direction and the second point
		#pt1=@ip1.position
		pt1=@points[-1]
		pt2=@ip2.position if !@perpi
		pt2=@per_point if @perpi				
		vec=pt2 - pt1
		if vec.length == 0.0
			UI.beep
			return
		end
		vec.length=value
		pt2=pt1 + vec
		@points<<pt2 ###

		self.create_geometry(pt1,pt2,view)# Create a line
		#self.reset(view)
		@state=1
		#@ip1.copy!(@ip2) ###
		@ip1 = Sketchup::InputPoint.new(pt2)
		@ip2.clear
		#@ip1.clear
		###

		  cline=view.model.active_entities.add_cline(pt1,pt2)###
		  #cline.stipple="_"
		  @lines<<cline

		view.invalidate
	end

	# Create new geometry when the user has selected two points.
	def create_geometry(p1, p2, view)
	
	  @points.each{|p|
		c=view.model.active_entities.add_cpoint(p)
		@lines<<c
	  }
	  c=view.model.active_entities.add_cpoint(p1)
	  @lines<<c
	  c=view.model.active_entities.add_cpoint(p2)
	  @lines<<c
		if @points[0]
		  cline=view.model.active_entities.add_cline(@points[-1],p2)### not p1,p2

		  #cline.stipple="_"
		  @lines<<cline
		end#if
	  ### clines give something to snap to...
	  
			
	end


	def resume(view)
	  view.invalidate if view

	  if @state==0
		Sketchup::set_status_text("Start-Point",SB_VCB_LABEL)
		Sketchup::set_status_text("-Pick Start Point...",SB_PROMPT)
	  else
		Sketchup::set_status_text("Length",SB_VCB_LABEL)
		Sketchup::set_status_text("-Pick End Point [Hit down key to toggle perpendicular lock] [Press Return for pipe or Double-click the Last-Point to End this Line-Set] [Double Right-click to undo last line].",SB_PROMPT)
	  end#if
	end

	# The draw method is called whenever the view is refreshed.
	# It lets the tool draw any temporary geometry that it needs to.
	def draw(view)
		if @ip1.valid?
			if @ip1.display?
				@ip1.draw(view)
				@drawn=true
			end
			if @ip2.valid?
				@ip2.draw(view) if @ip2.display?
				p1=@ip1.position
				p2=@ip2.position if @perpi==false or (@points.length<=1)
				p2=@per_point if (@perpi==true and (@points.length>1))
				self.draw_geometry(p1,p2,view)
				@drawn=true
			end
		end
	end

	# Draw the geometry
	def draw_geometry(pt1, pt2, view)

	###view.draw_line(pt1,pt2)
	# The set_color_from_line method determines what color
	# to use to draw a line based on its direction.
	# For example red, green or blue.
	pt3=@points[-1] # last point of "ready" line
	view.set_color_from_line(pt3, pt2) # draw line according to mouse move
	view.draw_line(pt3,pt2)if @points[0] # actually they are @ip1, @ip2 positions
	
	#Calculate the angle between the last two line and display it dynamically (also used in VCB)
		if (@points.length>1)
			va1=pt3.vector_to @points[-2]
			va2=pt3.vector_to @ip2.position if !@perpi
			va2=pt3.vector_to @per_point if @perpi
			@angle_curr=va1.angle_between va2
			@text=(((@angle_curr.radians*100).round)/100.0).to_s 
			#view.draw_text(@points[0], @text+"°") # removed because it not to nicely placed :-(
					
		end
		
		
	#Draw blue line when they are "ready"
		0.upto(@points.length-2) do |i|
			#view.set_color_from_line(@points[i],@points[i+1])
			view.line_width=2
			view.drawing_color = 'blue'
			view.draw_polyline(@points[i],@points[i+1])
		end

	#Draw open rectangle on actual /ip2.position/ or /mouse cursor/ location

	view.draw_points([@ip2.position],20,4,"black") if !@perpi
	view.draw_points([@ip2.position],20,1,"green")
	view.draw_points([@ip2.position],20,1,"yellow") if @ip2.edge
	view.draw_points([@ip2.position],20,1,"seagreen") if @ip2.face
	view.draw_points([@ip2.position],20,1,"teal") if @ip2.vertex
	#view.guess_target
	view.draw_points([@per_point],20,4,"black") if (@points.length>1) && @perpi
	view.draw_points([@per_point],20,1,"green") if (@points.length>1) && @perpi
	
	#Draw coloured indication of possible bends
		if (@points.length>0)
			d=[];d[0]=0 # to store lengths of segments
			b=[];b[0]=0 # to store lengths of bend
			for i in (0..@points.length-1)
				if @points.length==1 # we have only the start point
					if ((@points[i-1].distance pt2)-@rbe)<-0.000010
							view.line_width=5
							view.drawing_color = 'yellow'
							view.draw_line(@points[i-1], pt2)
						elsif ((@points[i-1].distance pt2)-@rbe)>=-0.000010 and ((@points[i-1].distance pt2)-2*@rbe)<=-0.000010
							vector1 = pt2.vector_to @points[i-1]
							vector1.length=(@points[i-1].distance pt2)-@rbe
							pu2 = pt2.offset vector1
							view.line_width=5
							view.drawing_color = 'yellow'
							view.draw_line(pt2, pu2)
							view.drawing_color = 'green'
							view.draw_line(@points[i-1], pu2)
						elsif ((@points[i-1].distance pt2)-2*@rbe)>=-0.000010
							vector2 = pt2.vector_to @points[i-1]
							vector2.length=@rbe
							pu2 = pt2.offset vector2
							pu3 = @points[i-1].offset vector2.reverse
							view.line_width=5
							view.drawing_color = 'green'
							view.draw_line(pt2, pu2)
							view.draw_line(@points[i-1], pu3)	
						else
						
					end					
				
				elsif @points.length>1 # we have at least one line, plus the "dynamic" end segment by moving mouse
			next if i==0 # we will start with 2nd point.
							v1=@points[i].vector_to @points[i-1]
							v2=@points[i].vector_to @points[i+1] if i<@points.length-1 #static vector
							v2=@points[i].vector_to pt2 if i==@points.length-1 #dynamic vector
							v3=v2.reverse
							v3.length=@rbe if v3.length>0
							d1=v1.length #1st line length on point
							d<<d1
							d2=v2.length #2nd line length on point
							a1=v1.angle_between v2
							b1=@rbe/Math.tan(a1/2) # the real length occupied by bend
							b<<b1
							v1.length=b1 if v1.length>0
							v2.length=b1 if v2.length>0
							
						if (d2-b1)<-0.00001 or d[i]-b[i]-b[i-1]<-0.00001 
							view.draw_points([@points[i]],20,7,"red")
							view.line_width=5
							view.line_stipple = ""
							view.drawing_color = 'yellow'
							view.draw_line(@points[i], pt2) if i==@points.length-1
							view.draw_line(@points[i], (@points[i].offset v2))
							view.draw_line(@points[i], (@points[i].offset v1))

						elsif (d1-b1)>=-0.000010 and (d2-b1)>=-0.000010
							view.line_width=5
							view.line_stipple = ""
							view.drawing_color = 'green'
							view.draw_line(@points[i], (@points[i].offset v1))
							view.draw_line(@points[i], (@points[i].offset v2))
							
							if (d2-b1-@rbe)>-0.000010
								view.line_width=5
								view.line_stipple = ""
								view.drawing_color = 'turquoise'
								view.draw_line((pt2.offset v3), pt2) if i==@points.length-1
							end
						else
						end
				end #if
		
			
			end #for
		end #if
	
	
=begin	earlier version.... not used 
		if ((pt3.distance pt2)-@rbe)<=0
			view.line_width=5
			view.drawing_color = 'yellow'
			view.draw_line(pt3, pt2)
		end

		if ((pt3.distance pt2)-@rbe)>0 and ((pt3.distance pt2)-2*@rbe)<0
			vector1 = pt2.vector_to pt3
			vector1.length=(pt3.distance pt2)-@rbe
			pu2 = pt2.offset vector1
			view.line_width=5
			view.drawing_color = 'orange'
			view.draw_line(pt2, pu2)
			view.drawing_color = 'green'
			view.draw_line(pt3, pu2)
		end

		if ((pt3.distance pt2)-2*@rbe)>0
			vector2 = pt2.vector_to pt3
			vector2.length=@rbe
			pu2 = pt2.offset vector2
			pu3 = pt3.offset vector2.reverse
			view.line_width=5
			view.drawing_color = 'green'
			view.draw_line(pt2, pu2)
			view.draw_line(pt3, pu3)
		end
=end
	end

	# onCancel is called when the user hits the escape key
	def onCancel(flag, view)
		@lines.each{|e|e.erase! if e.valid?}

		self.reset(view)
	end

	# user completes line-set or cancels
	#def onReturn(view)### v3.2 removed as VCB clash

	# double click end line-set
	def onLButtonDoubleClick(flags, x, y, view)
		self.end_geometry(view)
	end
	
		# Enter end line-set
	def onReturn(view)
		self.end_geometry(view)
				Dezmo_pompi2016::find_edges_vertices(@kind)
	end

	# The following methods are not directly called from SketchUp.  They are
	# internal methods that are used to support the other methods in this class.
	###
	def end_geometry(view)
	  #view.model.start_operation("PomPi Line",true)
		if @points[1]### can make a line
			self.create_geometry(@points[-2],@points[-1],view)
			@lines.each{|e|e.erase! if e.valid?}

			Sketchup.active_model.selection.add((Sketchup.active_model.active_entities.add_curve(@points)))
			#view.model.active_entities.add_curve(@points)if @points[1]
			#0.upto(@points.length-2) do |i|
			#  view.model.active_entities.add_line(@points[i],@points[i+1])
			#end#upto
		  view.invalidate
		  self.reset(view)
		  Sketchup.send_action("selectSelectionTool:")
		  
		else ### cancelled
		  view.invalidate
		  Sketchup::set_status_text("",SB_PROMPT)
		  Sketchup.send_action("selectSelectionTool:")
		end#if
	  #view.model.commit_operation
	end#def

	# Reset the tool back to its initial state
	def reset(view)
		# This variable keeps track of which point we are currently getting
		
		 Sketchup.send_action("selectSelectionTool:") if @state==0
		@state=0
		# clear the InputPoints
		@ip.clear
		@ip1.clear
		@ip2.clear
		if view
			view.tooltip=nil
			view.lock_inference
			view.invalidate if @drawn
		end
		@drawn=false
		@dragging=false
		@lines=[]
		@points=[]
		# Display a prompt on the status bar
		Sketchup::set_status_text(" - Pick Start Point...",SB_PROMPT)
		Sketchup::set_status_text("Start-Point",SB_VCB_LABEL)
		Sketchup::set_status_text("",SB_VCB_VALUE)
	end

	# One, (the last one) line undo. Note: the cline/cpoint will be not removed
	def onRButtonDoubleClick(flags, x, y, view)
		if @state==1 and @points.length>1
		@ip1 = Sketchup::InputPoint.new(@points[-2])
		@points.pop
		end
	end
	
	end # class

	#-----------------------------------------------------------------------------
	# shortcut
	def line_for_pipe_auto
		Sketchup.active_model.select_tool Pompi_line_tool_auto.new
	end
######-----------------------------------------------
end #module Dezmo_pompi2016
