#PomPi 2016 Copyright 2016-2018, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#---------------------------------------------------------------------------- 

module Dezmo_pompi2016
####################################################################################	
#	Creating reducer (or pipe if diameters are same, but the name is still reducer)
	def self.pompi_reducer()
	mod = Sketchup.active_model # Open model
	ent = mod.entities # All entities in model
	sel = mod.selection # Current selection
	definitions = mod.definitions # all component definitions
	
	mod.start_operation("PomPi: Create reducer.",true)

# New 2018	
layer_act = mod.active_layer
pompi_layer_pipe=mod.layers.add("PomPi_@")
pompi_layer_cent=mod.layers.add("PomPi_cl")	
# New 2018	
	
	vb = Geom::Vector3d.new 0,0,1 # vector for base circle
	c_ba = Geom::Point3d.new 0,0,0 #center of base circle
	c_ba1 = Geom::Point3d.new 0,0,@lre # this is a center line endpoint (start is the origin)
	
	pipe = mod.definitions.add "Reducer "
	entities = pipe.entities
	pipe.name = @cnam1 + @cdes1
	pipe.description =   "PomPi " + Time.now.to_s
	# puts  pipe.name , pipe.description  # debug
pipe.behavior.is2d         = true
pipe.behavior.cuts_opening = true

# New 2018
mod.active_layer = pompi_layer_pipe
# New 2018		

	
	group0 = entities.add_group #outer cone

	# Create a base outer circle according circle/polygon
	if @ngo == "1"
		b_base_o = group0.entities.add_circle(c_ba, vb, @ro1, @spi)
		else 
		b_base_o = group0.entities.add_ngon(c_ba, vb, @ro1, @spi)
	end #if
	face_base_o = group0.entities.add_face(b_base_o) # the cone outer, base face 

	# Rotate the cross-section:
	trpi = Geom::Transformation.rotation c_ba, vb, @rpi # transform
	group0.entities.transform_entities(trpi, face_base_o) 	

bv1=[]	
face_base_o.vertices.each{|v| bv1<<((v.position))}	

	# Get the outer pipe
	face_base_o.pushpull(@lre, true)
	face_base_o = face_base_o.reverse! # the face orientation must be change (don't ask why... I'll never ever understand it.)

	# Reduce/enlarge the end face
	trred = Geom::Transformation.new (@ro2/@ro1)
	group0.entities.transform_entities(trred, face_base_o)
	# if ex-centric we need to move the end face
	if (@kind == "redu_exc")
		vectrex = Geom::Vector3d.new 0,(@ro2-@ro1),0 # vector for move
		trredex = Geom::Transformation.new vectrex
		group0.entities.transform_entities(trredex, face_base_o)
		c_ba2 = Geom::Point3d.new 0,(@ro2-@ro1),@lre # this is a center line endpoint (start is the origin)
		c_ba1 = Geom::Point3d.new 0,0,@lre/2 # this is a center line endpoint (start is the origin)
		c_ba3 = Geom::Point3d.new 0,(@ro2-@ro1),@lre/2 # this is a center line endpoint (start is the origin)
	end

	# inner cone if we have valid inner radius
	if ((@ri1 != 0) && (@ri2 != 0))
		group1 = entities.add_group #inner cone
	
		# Create a base inner circle according circle/polygon
		if @ngo == "1"
			b_base_i = group1.entities.add_circle(c_ba, vb, @ri1, @spi)
			else 
			b_base_i = group1.entities.add_ngon(c_ba, vb, @ri1, @spi)
		end #if	
		face_base_i = group1.entities.add_face(b_base_i) # the cone inner, base face 
		# Rotate the cross-section:
		group1.entities.transform_entities(trpi, face_base_i) 		
		# Get the outer pipe
		face_base_i.pushpull(@lre, true)
		# Reduce/enlarge the end face
		trredi = Geom::Transformation.new (@ri2/@ri1)
		group1.entities.transform_entities(trredi, face_base_i)
		# if ex-centric we need to move the end face
		if (@kind == "redu_exc")
			vectrexi = Geom::Vector3d.new 0,(@ro2-@ro1),0 # vector for move same as for outer
			trredexi = Geom::Transformation.new vectrexi
			group1.entities.transform_entities(trredexi, face_base_i)
		end			 
		# remove inner cone
		group0 = group1.subtract(group0)
		
	end #if 
	# move up to origin
	vecupp = Geom::Vector3d.new 0,0,@lre
	trupp = Geom::Transformation.new vecupp
	pipe.entities.transform_entities(trupp, group0)		
	# explode the group, because we are inside of component and it is enough for me
	group0.explode

# New 2018
mod.active_layer = pompi_layer_cent
# New 2018	
	
	# The center lines for guide 
	line1 = pipe.entities.add_line(c_ba, c_ba1)
	line2 = pipe.entities.add_line(c_ba2, c_ba3) if @kind == "redu_exc"

magic0=[];magic1=[]
magic0=[c_ba, c_ba1] if @kind == "redu_conc"
magic0=[c_ba, c_ba1, c_ba2, c_ba3] if @kind == "redu_exc"
magic1=[[nil],bv1]
pipe.set_attribute "PomPi", "Magic_points0", magic0	
pipe.set_attribute "PomPi", "Magic_points1", magic1	
	
# New 2018
mod.active_layer = layer_act
# New 2018	
	
	Sketchup.active_model.select_tool Dezmo_pompi2016::Place_pompi_component.new pipe, @kind, @rbe, @abe	
			
	#mod.commit_operation
	end # self.pompi_reducer


end #module Dezmo_pompi2016