#PomPi 2016 Copyright 2016-2018, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
#---------------------------------------------------------------------------- 

=begin
########This code is based on AxisPivot by Thomas Thomassen ### Thanks!########
# Thomas Thomassen
# thomas[at]thomthom[dot]net
# http://sketchucation.com/forums/viewtopic.php?p=247067#p247067
###############################################################################
###############################################################################
#Also thanks to Julia Christina Eneroth: Part of 3D Rotate Tool (see below).
###############################################################################

Created and modified by Dezmo (2016). 

The "pipe" created by PomPi handled over to this tool to make "final" rotation.
You can use it independently as well.
This will rotate one component instance using 'his' z axis.
This will "twist" (rotate the start face) only PomPi pipe using 'his' z axis.

=end
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#-----------------------------------------------------------------------------
require 'sketchup.rb'
#-----------------------------------------------------------------------------
module Dezmo_pompi2016 

	# Prepare the rotation of PomPi component...or any component (I have taken out the limitaion so NOT ONLY for PomPi component...)
  def self.Pompi_Rotate_tool

    model = Sketchup.active_model
    sel = model.selection
	
#NEW2018_2
    if sel.single_object? && (sel[0].is_a?(Sketchup::ComponentInstance) || sel[0].is_a?(Sketchup::Group))
		if (sel[0].description.include? "PomPi") 		
				if (sel[0].definition.name.include? "pipe ") 
					sel_kind="pipe"
				 elsif (sel[0].definition.name.include? "bend ") 
					sel_kind="bend"
				 elsif (sel[0].definition.name.include? "t_short") 
					sel_kind="t_short"
				 elsif (sel[0].definition.name.include? "t_equal") 
					sel_kind="t_equal"
				 elsif (sel[0].definition.name.include? "reducer_e") 
					sel_kind="redu_exc"
				 elsif (sel[0].definition.name.include? "reducer_c") 
					sel_kind="redu_conc"
				 elsif (sel[0].definition.name.include? "union ") 
					sel_kind="union1"
				 elsif (sel[0].definition.name.include? "union_fake") 
					sel_kind="union2"
				 elsif (sel[0].definition.name.include? "flange ") 
					sel_kind="flange1"
				 elsif (sel[0].definition.name.include? "flange_fake") 
					sel_kind="flange2"
				else
					sel_kind="Custom"					
				end 
			else
				sel_kind="Custom"			
		end
		model.tools.push_tool( Pompi_Rotate.new( sel[0],sel_kind,0 ) )
#NEW2018_2

	else
	  UI.messagebox('No selection, or selection is not a single Component/Group!', MB_OK)
    end
  end
  
	# Prepare twisting of only PomPi pipe component (Other componet my cause problems, so disabled)
	#(Automaticaly select the base face and rotate, the other entities of pipe are not rotated so it is twisting )
  def self.Pompi_Twist_tool

    model = Sketchup.active_model
    sel = model.selection
    if (sel.single_object?) && (sel[0].is_a?(Sketchup::ComponentInstance)) && (sel[0].description.include? "PomPi") && (sel[0].definition.name.include? "pipe") 
      model.tools.push_tool( Pompi_Rotate.new( sel[0],"tw",0 ) )
	  else
	  UI.messagebox('No selection, or selection is not a single PomPi Pipe Component!', MB_OK)

    end
  end


class Pompi_Rotate 

 #APERTURE = 10
  
    def initialize(instance,kind,shift)
		model = Sketchup.active_model
		sel = model.selection
		sel.clear
		@instance = instance
		@ordef=instance.definition #store the original definition
	  	@kind = kind
		
#NEW2018_2
		@shift=shift

		if @kind!="Custom"
			@arr=[];@arr1=[]
			@arr=instance.definition.get_attribute("PomPi", "Magic_points0")
			@arr1=instance.definition.get_attribute("PomPi", "Magic_points1")
			#@vec_z=(@arr[0][2].vector_to @arr[0][3]).length if @kind.include? "t_short"
		end
#NEW2018_2

		@cpoint_visible=Sketchup.active_model.rendering_options["HideConstructionGeometry"] #check if constuction point visible & store it
		Sketchup.active_model.rendering_options["HideConstructionGeometry"]=false
		@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_ro.png"), 0, 0) if !(@kind=="tw")
		@cursor = UI.create_cursor(File.join(File.dirname(__FILE__), "/cur_tw.png"), 0, 0) if @kind=="tw"
    end


    def activate
		@angle = 0 # rotation angle	
		@ldown=nil # help bit if mouse click Lbutton or hit enter
		@group0=nil #group for cpoints (protractor)
		ar_bbinst=[@instance.bounds.height,@instance.bounds.depth,@instance.bounds.width] # instance bound dim
		ar_bbinst=ar_bbinst.sort #short it
		@s_rad = 1.2*ar_bbinst[1] #radius of 'protractor' (1.2*(2nd smallest bound dim))
		@s_rad = 2*ar_bbinst[1] if @kind.include? "t_short2" #radius of 'protractor' (2*(2nd smallest bound dim))
		@ip0=Sketchup::InputPoint.new #standard inputpoint
		@ip0.clear
		@tr_inst = @instance.transformation #the instance transformation (original)
		
		case @shift
			when 0
				@vec_x = @tr_inst.xaxis #the instance xaxis ,not used
				@vec_y = @tr_inst.yaxis #the instance yaxis ,the protactor plane
				@vec_z = @tr_inst.zaxis #the instance zaxis ,rotation about this axis.
				insp= @instance.definition.insertion_point
			when 1
				if @kind.include?"t_"
					@vec_z=((@arr[1].vector_to @arr[0]).transform(@tr_inst))
					@vec_y=(@tr_inst.yaxis)
					insp=@arr[1]
				end
				if  @kind=="redu_exc"
					@vec_z=((@arr[2].vector_to @arr[3]).transform(@tr_inst))
					@vec_y=(@tr_inst.yaxis)
					insp=@arr[2]
				end
				if @kind=="pipe" or  @kind=="redu_conc" or @kind.include?"union" or @kind.include?"flange" or  @kind=="tw"
					@vec_z=((@arr[1].vector_to @arr[0]).transform(@tr_inst))
					@vec_y=(@tr_inst.yaxis)
					insp=@arr[1]
				end	
				if @kind=="bend"
					@vec_z=((@arr[-1].vector_to @arr[-2]).transform(@tr_inst))
					flv=flattenVector([@arr[-1],@vec_z], @tr_inst.yaxis)
					@vec_y=(@tr_inst.zaxis).reverse
					@vec_y=flv if flv and flv.length>0
					insp=@arr[-1]
				end	
			when 2
				if @kind.include?"t_"
					@vec_z=((@arr[3].vector_to @arr[2]).transform(@tr_inst))
					@vec_y=(@tr_inst.zaxis)
					insp=@arr[3]
				end
		end
		@pt0 = insp.transform(@tr_inst) #pivot point
		
	# For twist:
		if @kind=="tw"
			Sketchup.active_model.start_operation('PopPi Twist about z-Axis',true)
			@instance.make_unique		
			pompient=@instance.definition.entities
				@pompi_pipe_faces = pompient.find_all {|e| 
					e.kind_of?(Sketchup::Face) and (e.normal.transform @tr_inst).parallel? @vec_z and @pt0.transform(@tr_inst.inverse).on_plane? e.plane
				} #start & end faces of pipe
			@as=Math::PI/(@pompi_pipe_faces[0].outer_loop.edges.length) #angle/2 defined by 1 segment (this is max allowed here)
			@points=[]
			@pompi_pipe_faces[0].outer_loop.vertices.find_all{|v| @points<<v.position.transform(@tr_inst)}
		end
		Sketchup.active_model.start_operation('PopPi Rotate about z-Axis',true) if !(@kind=="tw")
		my_protractor
		
    end

	
	def onSetCursor
		UI.set_cursor @cursor
	end#def	
		
	def my_protractor()
	
		# ...At least the first half of protractor... :-)
		#Sketchup.active_model.start_operation('PopPi Rotate about z-Axis',true) if !(@kind=="tw")

	  	  #Protractor	  
		@group0 = Sketchup.active_model.entities.add_group
	  	prot0 = []
		prot1 = []
		prot0[0]=(@pt0.offset @vec_y,3*@s_rad/2)
		prot1[0]=(@pt0.offset @vec_y,1.1*@s_rad)
		trprot=Geom::Transformation.rotation(@pt0,@vec_z,15.degrees)
		trprot1=Geom::Transformation.rotation(@pt0,@vec_z,7.5.degrees) 
		prot1[0].transform!(trprot1)
        (1..24).each{|i|
			prot0[i]= prot0[i-1].clone
			prot0[i].transform!(trprot)
			@group0.entities.add_cpoint(prot0[i])
			prot1[i]= prot1[i-1].clone
			prot1[i].transform!(trprot)
			@group0.entities.add_cpoint(prot1[i]) 		
        }
		@cpoint0 = @group0.entities.add_cpoint(@pt0.offset @vec_y,1.3*@s_rad)
		cline0 = (0..23).each{|i| @group0.entities.add_cline(prot0[i],prot0[i+1])}
		
		if @kind=="tw"
			@point_l = (@pt0.offset @vec_y,0.9*@s_rad)
			tr_twmin = Geom::Transformation.rotation(@pt0,@vec_z,@as) 
			tr_twmax = Geom::Transformation.rotation(@pt0,@vec_z,-@as)
			@point_l = @point_l.clone
			@point_l1 = @point_l.clone
			@point_l1.transform!(tr_twmax)
			@point_l2 = @point_l.clone
			@point_l2.transform!(tr_twmin)

			limitline = @group0.entities.add_cline(@point_l2,@point_l1)	
			#limitline.split 0.5
		end
	end	
	
	
	def onCancel(flags, view)
		view.invalidate
		Sketchup.send_action "selectSelectionTool:"
	end
	
	def reset
		Sketchup.active_model.rendering_options["HideConstructionGeometry"]=@cpoint_visible #restore the original visibility
		@group0.erase! if !@group0.deleted? #erase protactor
		@group0=nil
		@instance.definition=@ordef if (@angle==0 and @kind=="tw")
		@angle = 0 #set the angle to 0 than rotate bsack to it if tool cancelled

		if !@ldown		
			ti = @instance.transformation #the instance transformation (current)
			tii = ti.inverse #inverse of above
			tr = Geom::Transformation.rotation(@pt0, @vec_z, -@angle) # the current (local) transformation
			@instance.transform! tr*@tr_inst*tii  if !(@kind=="tw")
			Sketchup.active_model.abort_operation
		end
		Sketchup.active_model.commit_operation if @ldown
		@ldown=nil
		@ip0.clear
		sel = Sketchup.active_model.selection
#		sel.clear
		Sketchup.active_model.active_view.refresh
		
	end
	
    def deactivate(view)
		view.invalidate
		#sel = Sketchup.active_model.selection
		#sel.clear
		@instance.definition=@ordef if (@angle==0 and @kind=="tw")
		self.reset
    end

    def onLButtonDown(flags, x, y, view)
		#For twist
		if @kind=="tw"
			entities=@instance.definition.entities
			trtw=Geom::Transformation.rotation(@pt0.transform(@tr_inst.inverse), @pompi_pipe_faces[0].normal, @angle)
			entities.transform_entities(trtw, @pompi_pipe_faces[0])
			@instance.definition=@ordef if (@angle==0)
			if !(@angle==0)
				orig_name_angle=@instance.definition.name.split (' TW')
				new_angle=(1000.0*((orig_name_angle[1]).to_f-@angle.radians)).round/1000.0
				@instance.definition.name =orig_name_angle[0]+" TW"+new_angle.to_s if new_angle.abs>=0.0974
				@instance.definition.name =orig_name_angle[0] if new_angle.abs<0.0974
			end
		end

		@ldown=true
		Sketchup.active_model.active_view.refresh
		Sketchup.send_action "selectSelectionTool:"
    end
	
	def onReturn(view)
		#For twist
		if @kind=="tw"
			entities=@instance.definition.entities
			trtw=Geom::Transformation.rotation(@pt0.transform(@tr_inst.inverse), @pompi_pipe_faces[0].normal, @angle)
			entities.transform_entities(trtw, @pompi_pipe_faces[0])
			@instance.definition=@ordef if (@angle==0)
			if !(@angle==0)
				orig_name_angle=@instance.definition.name.split (' TW')
				new_angle=(1000.0*((orig_name_angle[1]).to_f-@angle.radians)).round/1000.0
				@instance.definition.name =orig_name_angle[0]+" TW"+new_angle.to_s if new_angle.abs>=0.0974
				@instance.definition.name =orig_name_angle[0] if new_angle.abs<0.0974
			end
		end
		####
		@ldown=true
		Sketchup.active_model.active_view.refresh
		Sketchup.send_action "selectSelectionTool:"
	end	
	

    def onMouseMove(flags, x, y, view)

		@ip0.pick view,x,y 
		view.tooltip = @ip0.tooltip 
		view.refresh #refresh view (??What is the difference to view.invalidate??)
		#@tform = @ip0.transformation  #the input point transformation (current)
		ipp = @ip0.position #the input point (cursor) position
		vec_curr = @pt0.vector_to ipp #vector to cursor from insertion point (from component origin)
		plane = [@pt0,@vec_z] # plane of component base (x-y plane)
		@angle = angle_between_in_Plane(plane, @vec_y, vec_curr) #Thanks to: Julia Christina Eneroth (see below)
		
		#limit the twist to +- @as
		if @kind=="tw"
			if @angle<0
			@angle = -@as if @angle.abs>@as 
			else @angle>0
			@angle = @as if @angle.abs>@as
			end
		end
		
		@angletext = (((1000.0*@angle.radians).round)/1000.0).to_s # text to shown in VCB
		@anglelim= (((1000.0*@as.radians).round)/1000.0).to_s if (@kind=="tw")
		ti = @instance.transformation #the instance transformation (current)
		tii = ti.inverse #inverse of above	
		tr = Geom::Transformation.rotation(@pt0, @vec_z, -@angle) # the current (local) transformation
		@instance.transform! tr*@tr_inst*tii if !(@kind=="tw")#transform the component instance considering original&current transformations too
		Sketchup::set_status_text("Angle:",SB_VCB_LABEL) # shown in VCB
		Sketchup::set_status_text(@angletext,SB_VCB_VALUE) # shown in VCB
		Sketchup::set_status_text "You can use arrow key too! Left:-1; Right:+1; Down:-10; Up:+10; // Hit ´shift´ key to change rotation axis.",SB_PROMPT if !(@kind=="tw")
		Sketchup::set_status_text "You can use arrow key too! Left:-1; Right:+1; Down:-10; Up:+10; /Limit:+-"+@anglelim+" // Hit ´shift´ key to change rotation axis.",SB_PROMPT if (@kind=="tw")
		view.invalidate #refresh view (??What is the difference to view.refresh??)
    end


	def onKeyDown(key, repeat, flags, view)
		if key==VK_LEFT or key==VK_RIGHT or key==VK_UP or key==VK_DOWN 
			case key
				when VK_LEFT then @angle +=-1.degrees if (@kind=="tw" and @angle.abs<@as ) or !(@kind=="tw")
				when VK_RIGHT then @angle +=1.degrees if (@kind=="tw" and @angle.abs<@as ) or !(@kind=="tw")
				when VK_UP then @angle +=10.degrees if (@kind=="tw" and @angle.abs<@as ) or !(@kind=="tw")
				when VK_DOWN then @angle +=-10.degrees if (@kind=="tw" and @angle.abs<@as ) or !(@kind=="tw")
			end
			@angletext = (((1000.0*@angle.radians).round)/1000.0).to_s # text to shown in VCB
			@anglelim= (((1000.0*@as.radians).round)/1000.0).to_s if (@kind=="tw")
			ti = @instance.transformation #the instance transformation (current)
			tii = ti.inverse #inverse of above
			tr = Geom::Transformation.rotation(@pt0, @vec_z, -@angle) # the current (local) transformation
			@instance.transform! tr*@tr_inst*tii  if !(@kind=="tw")#transform the component instance considering original&current transformations too
			Sketchup::set_status_text("Angle:",SB_VCB_LABEL) # shown in VCB
			Sketchup::set_status_text(@angletext,SB_VCB_VALUE) # shown in VCB
			Sketchup::set_status_text "Left:-1; Right:+1; Down:-10; Up:+10; /Limit:+-"+@anglelim+" // Hit ´shift´ key to change rotation axis.",SB_PROMPT if (@kind=="tw")
			Sketchup::set_status_text "Left:-1; Right:+1; Down:-10; Up:+10; // Hit ´shift´ key to change rotation axis.",SB_PROMPT if !(@kind=="tw")
		end
#new 2018_2	
		if( key == CONSTRAIN_MODIFIER_KEY )
			if @kind!="Custom"
				@shift+=1
				@shift=0 if (@shift>2 and (@kind.include?"t_" )) or (@shift>1 and !(@kind.include?"t_"))
				view.invalidate
			end
			case @shift
				when 0
					@vec_x = @tr_inst.xaxis #the instance xaxis ,not used
					@vec_y = @tr_inst.yaxis #the instance yaxis ,the protactor plane
					@vec_z = @tr_inst.zaxis #the instance zaxis ,rotation about this axis.
					insp= @instance.definition.insertion_point
					view.invalidate
				when 1
					if @kind.include?"t_"
						@vec_z=((@arr[1].vector_to @arr[0]).transform(@tr_inst))
						@vec_y=(@tr_inst.yaxis)
						insp=@arr[1]
					end
					if  @kind=="redu_exc"
						@vec_z=((@arr[2].vector_to @arr[3]).transform(@tr_inst))
						@vec_y=(@tr_inst.yaxis)
						insp=@arr[2]
					end
					if @kind=="pipe" or  @kind=="redu_conc" or @kind.include?"union" or @kind.include?"flange" or  @kind=="tw"
						@vec_z=((@arr[1].vector_to @arr[0]).transform(@tr_inst))
						@vec_y=(@tr_inst.yaxis)
						insp=@arr[1]
					end	
					if @kind=="bend"
						@vec_z=((@arr[-1].vector_to @arr[-2]).transform(@tr_inst))
						flv=flattenVector([@arr[-1],@vec_z], @tr_inst.yaxis)
						@vec_y=(@tr_inst.zaxis).reverse
						@vec_y=flv if flv and flv.length>0
						
						insp=@arr[-1]
					end	
					view.invalidate
				when 2
					if @kind.include?"t_"
						@vec_z=((@arr[3].vector_to @arr[2]).transform(@tr_inst))
						@vec_y=(@tr_inst.zaxis)
						insp=@arr[3]
					end
	
				view.invalidate
			end#case
		
			@pt0 = insp.transform(@tr_inst) #pivot point
			ti = @instance.transformation #the instance transformation (current)
			tii = ti.inverse #inverse of above
			tr = Geom::Transformation.rotation(@pt0, @vec_z, -@angle) # the current (local) transformation
			@instance.transform! tr*@tr_inst*tii  if !(@kind=="tw")
			
			if @kind=="tw"
				pompient=@instance.definition.entities
					@pompi_pipe_faces = pompient.find_all {|e| 
						e.kind_of?(Sketchup::Face) and (e.normal.transform @tr_inst).parallel? @vec_z and @pt0.transform(@tr_inst.inverse).on_plane? e.plane
					} #start & end faces of pipe
				@as=Math::PI/(@pompi_pipe_faces[0].outer_loop.edges.length) #angle/2 defined by 1 segment (this is max allowed here)
				@points=[]
				@pompi_pipe_faces[0].outer_loop.vertices.find_all{|v| @points<<v.position.transform(@tr_inst)}
				view.invalidate
			end	
			
			@group0.erase! if !@group0.deleted? #erase protactor
			@group0=nil
			my_protractor #create protactor again in new position 
			view.invalidate
		end#if key

		view.invalidate #refresh view		
	end# onKeyDown
	
	def onUserText(text, view)
		# We only accept input when the state is 1 (i.e. getting the second point)
		# This could be enhanced to also modify the last line created if a length
		# is entered after creating a line.
		return if not @ip0.valid?
		# The user may type in something that we can't parse as a length
		# so we set up some exception handling to trap that
		begin
			value=text.to_f
		rescue
			# Error parsing the text
			value=nil
			Sketchup::set_status_text("",SB_VCB_VALUE)
			Sketchup::set_status_text("Cannot convert "+text+" to a angle!",SB_PROMPT)
		end
		return if !value
		@angle = value.degrees		
		if (@kind=="tw")
			@anglelim= (((1000.0*@as.radians).round)/1000.0).to_s 
			Sketchup::set_status_text "Limit:+-"+@anglelim,SB_PROMPT 
			if value.degrees.abs>@as
			@angle = @as
			#return 
			end
		end
		@angletext = (((1000.0*@angle.radians).round)/1000.0).to_s
		ti = @instance.transformation #the instance transformation (current)
		tii = ti.inverse #inverse of above
		tr = Geom::Transformation.rotation(@pt0, @vec_z, -@angle) # the current (local) transformation
		@instance.transform! tr*@tr_inst*tii  if !(@kind=="tw")#transform the component instance considering original&current transformations too
		Sketchup::set_status_text("Angle:",SB_VCB_LABEL) # shown in VCB
		Sketchup::set_status_text(@angletext,SB_VCB_VALUE) # shown in VCB
		Sketchup::set_status_text "Left:-1; Right:+1; Down:-10; Up:+10; /Limit:+-"+@anglelim+" // Hit ´shift´ key to change rotation axis.",SB_PROMPT if (@kind=="tw")
		Sketchup::set_status_text "Left:-1; Right:+1; Down:-10; Up:+10; // Hit ´shift´ key to change rotation axis.",SB_PROMPT if !(@kind=="tw")
		view.invalidate
	end

	
    def draw(view)
		if( @ip0.valid? && @ip0.display? )
			@ip0.draw(view)
		end

      # Y axis (original direction)
	  view.line_width =  2
	  view.drawing_color = [0,255,0] 
	  view.draw_lines @pt0,(@pt0.offset @vec_y,1.3*@s_rad)
	  view.draw_points((@pt0.offset @vec_y,1.3*@s_rad), 5, 1, [0,255,0])
	  
      # Z axis (pivot axis)
	  view.line_width =  4
	  view.drawing_color = [0,0,255] 
	  view.draw_lines @pt0,(@pt0.offset @vec_z,@s_rad)
	  
      # Points
      view.line_width = 3
	  view.drawing_color = "magenta" 
      view.line_stipple = '_'
      view.draw_points(@pt0, 10, 4, [0,0,0]) # Pivot
	  view.draw_points(@ip0.position, 10, 1, "magenta") #ip (cursor) position 	  
	  view.draw_points(@ip0.position, 15, 2, "red")	if (@kind=="tw" and (@angle==-@as or @angle==@as))
	  view.draw_lines @ip0.position,@pt0  #line to ip (cursor) position 
	  
	  #Protractor ...(the second half)
	  	prot0 = []
		prot1 = []
		prot0[0]=(@pt0.offset @vec_y,1.1*@s_rad)
		prot1[0]=(@pt0.offset @vec_y,3*@s_rad/2)
		#trprot=Geom::Transformation.rotation(@pt0,@vec_z,15.degrees)
		trprot=Geom::Transformation.rotation(@pt0,@vec_z,7.5.degrees)
        (1..48).each{|i|
			prot0[i]= prot0[i-1].clone
			prot0[i].transform!(trprot)
			prot1[i]= prot1[i-1].clone
			prot1[i].transform!(trprot)
			view.drawing_color = "yellow"
			view.line_width = 1
			view.draw_lines prot1[i],@pt0 if i%4==0
			view.drawing_color = "gold"
			view.line_width = 2
			view.draw_lines prot1[i-2],@pt0 if i%4==0			
        }
		
        view.drawing_color = "magenta"
        view.line_width = 1
        view.line_stipple = '' 		
		view.draw GL_LINE_LOOP, prot0 #inner protractor
		#view.draw GL_LINE_LOOP, prot1 #outer protractor
		
		if @kind=="tw"
		loop=[]
		trtemp=Geom::Transformation.rotation(@pt0,@vec_z,-@angle)
		(0..(@points.length-1)).each{|i| loop<<@points[i].transform(trtemp)}
		view.drawing_color = "Maroon"
        view.line_width = 6 
        view.line_stipple = '' 		
		view.draw GL_LINE_LOOP, loop #inner protractor

		view.drawing_color = "green"
        view.line_width = 10 
        view.line_stipple = '' 		
		view.draw_lines @pt0, @point_l2
		view.draw_lines @pt0, @point_l1
	#	view.draw_lines @point_l2, @point_l1
		end
    end




######################## (This bits from:Eneroth3 ##############################
#Eneroth 3D Rotate Tool
#http://sketchucation.com/pluginstore?listtype=1&author=0&category=0&search=3D+rot&submit=%3F
#Author:	Julia Christina Eneroth, Eneroth3, eneroth3@gmail.com
	def angle_between_in_Plane(plane, v1, v2)
		#Get angle between vectors in a given plane
		#Can return negative angles unlike built in angleBetween method
		
		#Flatten to plane
		v1 = self.flattenVector(plane,v1)
		v2 = self.flattenVector(plane,v2)
		
		#Get angle between
		a = v1.angle_between v2
		
		#Determine if angle is positive or negative (rotate v2 90 degrees cc and cw seen from above and see which is closest to v2)
		negAnglePointForward = Geom::Point3d.new.offset v2
		negAnglePointPos = negAnglePointForward.transform(Geom::Transformation.rotation(Geom::Point3d.new, plane[1], Math::PI/2))
		negAnglePointNeg = negAnglePointForward.transform(Geom::Transformation.rotation(Geom::Point3d.new, plane[1], -Math::PI/2))
		negAnglePointCheck = Geom::Point3d.new.offset v1
		a*= -1 if (negAnglePointCheck.distance negAnglePointNeg) < (negAnglePointCheck.distance negAnglePointPos)
		
		return a
	end#def

	def flattenVector(plane, vector)
		#Flatten vector to plane
		#plane's point does not affect output, only its normal does
		
		pointStart = plane[0]
		normal = plane[1]
		
		#Point at end of vector
		pointVectorEnd = pointStart.offset vector
		#point projected to plane
		pointIntesection = pointVectorEnd.project_to_plane plane
		#vector from startpoint to intersection
		outputVector = pointIntesection.- pointStart
		return outputVector
	end#def	
######################## This bits from:Eneroth3) ##############################

end # class

=begin
Don't need this:
#----------------------------------------------------
# shortcut
#def Pompi_Rotate()
#    Sketchup.active_model.select_tool(Pompi_Rotate.new) 
#end
######-----------------------------------------------


### add menu item etc #####################################################
unless file_loaded?(File.basename(__FILE__))
  ### make command1
  text10 = "PomPi Rotate" 
  text11 = "PomPi Rotate" 
  text12 = "Axial-Rotate a Selection (ONLY Component) about z-Axis"+"..." 
  cmd1=UI::Command.new(text10){self.Pompi_Rotate_tool} 
  cmd1.tooltip=text11
  cmd1.status_bar_text=text12
  UI.menu("Plugins").add_item(cmd1)
  ### toolbar
  cmd1.small_icon=File.join(File.dirname(__FILE__), "/pompi_rot.png") 
  cmd1.large_icon=File.join(File.dirname(__FILE__), "/pompi_rot.png") 
  toolbar=UI::Toolbar.new(text10)
  toolbar.add_item(cmd1)
  toolbar.restore if toolbar.get_last_state==TB_VISIBLE
  ###
end#if
file_loaded(File.basename(__FILE__))
###
=end

end #module Dezmo_pompi2016 

