#PomPi 2016 Copyright 2016-2018, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#---------------------------------------------------------------------------- 

module Dezmo_pompi2016
####################################################################################	
#	Creating T's (two kind, two direction)
	def self.pompi_t_4()
	mod = Sketchup.active_model # Open model
	ent = mod.entities # All entities in model
	sel = mod.selection # Current selection
	definitions = mod.definitions # all component definitions
	
	mod.start_operation("PomPi: Create T.",true) 

# New 2018	
layer_act = mod.active_layer
pompi_layer_pipe=mod.layers.add("PomPi_@")
pompi_layer_cent=mod.layers.add("PomPi_cl")	
# New 2018	
	
	vb = Geom::Vector3d.new 0,0,1 # vector for base circle
	vb_t = Geom::Vector3d.new 0,1,0 # vector for base circle T leg
	vy = Geom::Vector3d.new 1,0,0 # vector for rotate T when insert
	c_ba = Geom::Point3d.new 0,0,0 #center of base circle
	c_ba1 = Geom::Point3d.new 0,0,2*@rbe # this is a center line endpoint (start is the origin)
	c_bat = Geom::Point3d.new 0,0,@rbe # this is a center line T leg (start )
	c_bat1 = Geom::Point3d.new 0,@lts,@rbe if @kind.include? "t_short" # if short T# this is a center line T leg (end)
	c_bat1 = Geom::Point3d.new 0,@rbe,@rbe if @kind.include? "t_equal" # if equal T# this is a center line T leg (end)
	
	pipe = mod.definitions.add "T_ "
	entities = pipe.entities
	pipe.name = @cnam1 + @cdes1
	pipe.description =  "PomPi " + Time.now.to_s
	# puts  pipe.name , pipe.description  # debug
pipe.behavior.is2d         = true
pipe.behavior.cuts_opening = true

# New 2018
mod.active_layer = pompi_layer_pipe
# New 2018		

	group0 = entities.add_group #outer T head	
	# Create a base outer circle according circle/polygon
	if @ngo == "1"
		b_base_o = group0.entities.add_circle(c_ba, vb, @ro1, @spi)
		else 
		b_base_o = group0.entities.add_ngon(c_ba, vb, @ro1, @spi)
	end #if
	face_base_o = group0.entities.add_face(b_base_o) # the T head outer, base face 
	
	# Rotate the cross-section:
	trpi = Geom::Transformation.rotation c_ba, vb, @rpi # transform
	group0.entities.transform_entities(trpi, face_base_o) 	
	# Get the outer pipe of T head
	face_base_o.pushpull(-2*@rbe, true)
	
	face_base_o = face_base_o.reverse! # the face orientation must be change (don't ask why... I'll never ever understand it.)
	# 	
	group1 = entities.add_group #outer T leg	
	# Create a base outer circle according circle/polygon
	if @ngo == "1"
		b_base_o_t = group1.entities.add_circle(c_bat, vb_t, @ro2, @spi)
		else 
		b_base_o_t = group1.entities.add_ngon(c_bat, vb_t, @ro2, @spi)
	end #if
	face_base_o_t = group1.entities.add_face(b_base_o_t) # the T leg outer, base face 
	
	# Rotate the cross-section:
	trpi_t = Geom::Transformation.rotation c_bat, vb_t, @rpi # transform
	group1.entities.transform_entities(trpi_t, face_base_o_t) 	
	# Get the outer pipe of T leg
	face_base_o_t.pushpull(@rbe, true) if @kind.include? "t_equal" # if normal T
	face_base_o_t.pushpull(@lts, true) if @kind.include? "t_short" # if short T
	
	 group0 = group0.union(group1) # get the solid union of outer T

	if (@ri1 != 0) 
		group2 = entities.add_group #inner T head	
		# Create a base inner circle according circle/polygon
		if @ngo == "1"
			b_base_i = group2.entities.add_circle(c_ba, vb, @ri1, @spi)
			else 
			b_base_i = group2.entities.add_ngon(c_ba, vb, @ri1, @spi)
		end #if
		face_base_i = group2.entities.add_face(b_base_i) # the T head inner, base face 
		
		# Rotate the cross-section:
		trpi = Geom::Transformation.rotation c_ba, vb, @rpi # transform
		group2.entities.transform_entities(trpi, face_base_i) 	
		# Get the inner pipe of T head
		face_base_i.pushpull(-2*@rbe, true)
	end #if
		
	if (@ri2 != 0)
		group3 = entities.add_group #outer T leg	
		# Create a base outer circle according circle/polygon
		if @ngo == "1"
			b_base_i_t = group3.entities.add_circle(c_bat, vb_t, @ri2, @spi)
			else 
			b_base_i_t = group3.entities.add_ngon(c_bat, vb_t, @ri2, @spi)
		end #if
		face_base_i_t = group3.entities.add_face(b_base_i_t) # the T leg outer, base face 
		
		# Rotate the cross-section:
		trpi_t = Geom::Transformation.rotation c_bat, vb_t, @rpi # transform
		group3.entities.transform_entities(trpi_t, face_base_i_t) 	
		# Get the outer pipe of T leg
		face_base_i_t.pushpull(@rbe, true) if @kind.include? "t_equal" # if normal T
		face_base_i_t.pushpull(@lts, true) if @kind.include? "t_short" # if short T
		
	end #if 
	# 
	group3 = group2.union(group3) if (group2 && group3) # get the solid union of inner T
	# remove inner T if we have
	group0 = group3.subtract(group0) if group3



	if ((@kind == "t_short2") || (@kind == "t_equal2"))
		vecdown = Geom::Vector3d.new 0,-@lts,-@rbe if @kind == "t_short2"
		vecdown = Geom::Vector3d.new 0,-@rbe,-@rbe if @kind == "t_equal2"
		trdown = Geom::Transformation.translation vecdown
		pipe.entities.transform_entities(trdown, group0)
		trr = Geom::Transformation.rotation c_ba, vy, -90.degrees
		pipe.entities.transform_entities(trr, group0)	
		c_ba1 = Geom::Point3d.new 0,0,@lts if @kind == "t_short2"
		c_ba1 = Geom::Point3d.new 0,0,@rbe if @kind == "t_equal2"
		c_bat = Geom::Point3d.new 0,-@rbe,@lts if @kind == "t_short2"
		c_bat1 = Geom::Point3d.new 0,@rbe,@lts if @kind == "t_short2"
		c_bat = Geom::Point3d.new 0,-@rbe,@rbe if @kind == "t_equal2"
		c_bat1 = Geom::Point3d.new 0,@rbe,@rbe if @kind == "t_equal2"
	end #if
	
	group0.explode 
	
# New 2018
mod.active_layer = pompi_layer_cent
# New 2018		

	# The center lines for guide 
	line = pipe.entities.add_line(c_ba, c_ba1)
	linet = pipe.entities.add_line(c_bat, c_bat1)		
	
magic0=[];magic1=[]
magic0=[c_ba, c_ba1,c_bat, c_bat1]
magic1=[nil,nil]
pipe.set_attribute "PomPi", "Magic_points0", magic0	
pipe.set_attribute "PomPi", "Magic_points1", magic1	
	
# New 2018
mod.active_layer = layer_act
# New 2018	
	
	Sketchup.active_model.select_tool Dezmo_pompi2016::Place_pompi_component.new pipe, @kind, @rbe, @abe	

	#mod.commit_operation
	end # self.pompi_t_4	


end #module Dezmo_pompi2016