#PomPi 2016 Copyright 2016-2018, Dezmo
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
# Tested: SKETCHUP 2014 Windows 7, SKETCHUP 2015&2016 Windows 10
# I'm using millimeter unit, I don't care the others...(but inch implemented and it should work).
#------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------
=begin

########This code is using some bits from others ### Thanks!########
Please check it below, and give thanks to them !
########This code is using some bits from others ### Thanks!########

Designed, created, modified, alterd... by Dezmo (2016). 
/Without any obligation/

Description:
You can create infinite variety of pipe elements. (pipe, bend, T, reducer,...)
Data/dimensions are predefined by CSV file(s) or manually entered via HTML UI.
Find more in the help file.

=end
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
#---------------------------------------------------------------------------- 

module Dezmo_pompi2016
####################################################################################	
#	Creating union or half of flange (or "fake" union / flange...)
	def self.pompi_uni_fla()
	mod = Sketchup.active_model # Open model
	ent = mod.entities # All entities in model
	sel = mod.selection # Current selection
	definitions = mod.definitions # all component definitions
	
	mod.start_operation("PomPi Create union or flange.",true) 

# New 2018	
layer_act = mod.active_layer
pompi_layer_pipe=mod.layers.add("PomPi_@")
pompi_layer_cent=mod.layers.add("PomPi_cl")	
# New 2018	
	
	vb = Geom::Vector3d.new 0,0,1 # vector for base circle
	c_ba = Geom::Point3d.new 0,0,0 #center of base circle
	c_bab = Geom::Point3d.new 0,@run,0 if @kind.include? "union" #center of base circle grove
	c_bab = Geom::Point3d.new 0,@cfl,0 if @kind.include? "flange" #center of base circle bolt
	c_ba1 = Geom::Point3d.new 0,0,@tun if @kind.include? "union1" # this is a center line endpoint (start is the origin)
	c_ba1 = Geom::Point3d.new 0,0,@lun if @kind.include? "union2" # this is a center line endpoint (start is the origin)
	c_ba1 = Geom::Point3d.new 0,0,@tfl if @kind.include? "flange" # this is a center line endpoint (start is the origin)
	
	pipe = mod.definitions.add "Uni_fla "
	entities = pipe.entities
	pipe.name = @cnam1 + @cdes1
	pipe.description =   "PomPi " + Time.now.to_s
	# puts  pipe.name , pipe.description  # debug
pipe.behavior.is2d         = true
pipe.behavior.cuts_opening = true

# New 2018
mod.active_layer = pompi_layer_pipe
# New 2018	
	
	# outher cylinder 
	group1 = entities.add_group #outher cylinder 

	# Create a base outer circle according circle/polygon
	if @ngo == "1"
		b_base_i = group1.entities.add_circle(c_ba, vb, @run, @spi) if @kind.include? "union" 
		b_base_i = group1.entities.add_circle(c_ba, vb, @rfl, @spi) if @kind.include? "flange" 
		else 
		b_base_i = group1.entities.add_ngon(c_ba, vb, @run, @spi) if @kind.include? "union" 
		b_base_i = group1.entities.add_ngon(c_ba, vb, @rfl, @spi) if @kind.include? "flange"
	end #if	
	face_base_i = group1.entities.add_face(b_base_i) # the cylinder outer, base face 
	# Rotate the cross-section:
	trpi = Geom::Transformation.rotation c_ba, vb, @rpi # transform
	group1.entities.transform_entities(trpi, face_base_i) 		
	# Get the outer pipe
	face_base_i.pushpull(@tun, true) if @kind.include? "union"
	face_base_i.pushpull(@tfl, true) if @kind.include? "flange"
	face_base_i=face_base_i.reverse!	
	
	# bolt holes or groves & inner pipe only for union1 and flange1
	if (@kind=="union1" or @kind=="flange1")
		groupb=[]
		group0 = entities.add_group #inner cylinder, (pipe outside dia, will be removed)
		groupb[0] = entities.add_group #inner cylinder bolt 1, (will be removed)

		# Create a base inner circle  and bolt holes according circle/polygon
		if @ngo == "1"
			b_base_o = group0.entities.add_circle(c_ba, vb, @ro1, @spi) #base circle
			b_base_bolt = groupb[0].entities.add_circle(c_bab, vb, @crfl, 12) #bolt/grove (always 12 segments)
			else 
			b_base_o = group0.entities.add_ngon(c_ba, vb, @ro1, @spi)
			b_base_bolt = groupb[0].entities.add_ngon(c_bab, vb, @crfl, 12)
		end #if
		face_base_o = group0.entities.add_face(b_base_o) # the cylinder inner, base face 
		face_base_bolt = groupb[0].entities.add_face(b_base_bolt) # the bolt/grove, base face 
		
		# Rotate the cross-section:
		trpi = Geom::Transformation.rotation c_ba, vb, @rpi # transform
		group0.entities.transform_entities(trpi, face_base_o) 	
		
		# Get the inner cylinder
		face_base_o.pushpull(@tun, true) if @kind.include? "union" 
		face_base_o.pushpull(@tfl, true) if @kind.include? "flange"
		#face_base_o = face_base_o.reverse! # the face orientation must be change (don't ask why... I'll never ever understand it.)
		
		# Get one bolt
		face_base_bolt.pushpull(@tun, true) if @kind.include? "union" 
		face_base_bolt.pushpull(@tfl, true) if @kind.include? "flange"
		#face_base_bolt = face_base_bolt.reverse! # the face orientation must be change (don't ask why... I'll never ever understand it.)		
		
		# Clone the bolt 4 times (3 times if it is triangle) and remove from body
		i=0
		ii=4 if @spi>=4
		ii=3 if @spi<4
		rot=90 if @spi>=4
		rot=120 if @spi<4
		trbolt1 = Geom::Transformation.rotation c_ba, vb, (30).degrees if ii==3 # if segments=3 first hole rotated
		groupb[0].transform! trbolt1 if ii==3 # if segments=3 first hole rotated
		trbolt = Geom::Transformation.rotation c_ba, vb, (rot).degrees
		for i in 0...ii #(((@spi)/2)-1)
			groupb[i+1] = groupb[i].copy  if groupb[i]
			groupb[i+1].transform! trbolt
			group1 = groupb[i].subtract(group1) if groupb[i]
			i+=1 
		end
		group1 = groupb[i].subtract(group1) if groupb[i]
		
		# remove inner pipe
		group1 = group0.subtract(group1) if group0		
	end

		# move up to origin
		vecupp = Geom::Vector3d.new 0,0,@tun if @kind.include? "union1" 
		vecupp = Geom::Vector3d.new 0,0,((@tun+@lun)/2) if @kind.include? "union2" 
		vecupp = Geom::Vector3d.new 0,0,@tfl if @kind.include? "flange" 
		trupp = Geom::Transformation.new vecupp
		pipe.entities.transform_entities(trupp, group1)	

		# I nearly forget this, add "rod" for "union2" which is used as "fake" component ;-)
		if @kind.include? "union2" 
			group2 = entities.add_group
			# Create a base inner circle  and bolt holes according circle/polygon
			if @ngo == "1"
				b_base_r = group2.entities.add_circle(c_ba, vb, @ro1, @spi) #base circle
				else 
				b_base_r = group2.entities.add_ngon(c_ba, vb, @ro1, @spi)
			end #if
			face_base_r = group2.entities.add_face(b_base_r) # the cylinder inner, base face 
			face_base_r = face_base_r.reverse! # the face orientation must be change (don't ask why... I'll never ever understand it.)		
		group2.entities.transform_entities(trpi, face_base_r)
			face_base_r.pushpull(@lun, true)
			face_base_r = face_base_r.reverse!
		end
		group1 = group2.union(group1) if group2	# combine the body & pipe to solid

		
		# explode the group, because we are inside of component and it is enough for me
		group1.explode

# New 2018
mod.active_layer = pompi_layer_cent
# New 2018	
		
	# The center lines for guide 
	line1 = pipe.entities.add_line(c_ba, c_ba1)
	
magic0=[];magic1=[]
magic0=[c_ba, c_ba1]
magic1=[nil,nil]
pipe.set_attribute "PomPi", "Magic_points0", magic0	
pipe.set_attribute "PomPi", "Magic_points1", magic1	
		
# New 2018
mod.active_layer = layer_act
# New 2018		
	
	Sketchup.active_model.select_tool Dezmo_pompi2016::Place_pompi_component.new pipe, @kind, @rbe, @abe	
			
	#mod.commit_operation
	end # self.pompi_uni_fla


end #module Dezmo_pompi2016